/* connect.cc
 * Written by Joshua Rowe
 * API to create connections to regd servers
 */

#include	"reglib.h"

char	defhostname[]	= "127.0.0.1";

/* Some of the following code is copied from the GNU info manual */
/* Returns -1 on failure, reports an error in reglib_errno */

int	regd_connect(const char *hostname, unsigned short int port)
{
  int		sock;
  struct	sockaddr_in	server;

  if (port == 0)
    port	= 5500;
  if (hostname == 0)
    hostname	= defhostname;

  sock		= socket(PF_INET, SOCK_STREAM, 0);
  if (sock < 0)
    {
      reglib_errno	= errno;
      return -1;
    }
  if (!regd_initsockaddr(&server, hostname, port))
    return	-1;
  if (0 > connect(sock, (struct sockaddr *) &server, sizeof(server)))
    {
      reglib_errno	= errno;
      close(sock);
      return -1;
    }
  return sock;
}

/* Thanks guys! */


/* Following code taken with modifications from GNU info manual */
/* Returns 0 on failure, and 1 on success.  Sets reglib_errno. */

int	regd_initsockaddr(struct sockaddr_in *name, const char *hostname,
			  unsigned short int port)
{
  struct hostent *hostinfo;
     
  name->sin_family = AF_INET;
  name->sin_port = htons (port);
  hostinfo = gethostbyname (hostname);
  if (hostinfo == NULL)
    {
      reglib_errno	= RG_ERR_NOHOST;
      return 0;
    }
  name->sin_addr = *(struct in_addr *) hostinfo->h_addr;
  reglib_errno	= RG_ERR_SUCCESS;
  return 1;
}

/* Thanks guys */

