/* key.hh
 * Written by Joshua Rowe
 */

#ifndef	__REG_KEY_HH__
#define	__REG_KEY_HH__

class	RegKey;
typedef	RegKey *	pRegKey;

#include	"pios.hh"
#include	"val.hh"
#include	"reglib.h"

class	RegKey	: public pstreamable
{
  virtual char *	streamableName() const
    { return "RegKey"; }
protected:
  virtual pvoid		read(ipstream &is);
  virtual void		write(opstream &os);
public:
  pRegKey		parent, children, next, prev;
  pRegVal		vals;
  char *		name;
  int			uid, gid, mode;
  RegKey(char *aname = 0, int auid = 0, int agid = 0,
	 int amode = RKM_DEF, pRegKey aparent = 0);
  RegKey(pstreamableInit);
  virtual		~RegKey();
  int			access(int auid, int gid, int amode);
  static pstreamable *	build();
  char *		getfullname();
  virtual void		init();
};

inline opstream &	operator<<(opstream &os, pRegKey d)
{
  return os << (pstreamable *)d;
}

inline ipstream &	operator>>(ipstream &is, pRegKey &d)
{
  return is >> (pvoid &)d;
}

__PSTREAM_LINK(RegRegKey)

#endif
