/* val.cc
 * Written by Joshua Rowe
 */

#include	"val.hh"
#include	"string.h"

RegVal::RegVal(char *aname, char *adata, pRegKey aparent)
{
  init();
  if (aname != 0)		// If a name is provided, duplicate it
    {
      name	= new char[strlen(aname) + 1];
      strcpy(name, aname);
    }
  if (aparent != 0)		// Link into our parent's list
    {
      parent		= aparent;
      next		= parent->vals;
      if (next)
	next->prev	= this;
      parent->vals	= this;
    }
  if (adata)
    {
      data	= new char[strlen(adata) + 1];
      strcpy(data, adata);
    }
}

RegVal::RegVal(pstreamableInit)
{
  init();			// I know we aren't supposed to do anything
				// here, but I couldn't resist.
}

RegVal::~RegVal()
{
  if (data)
    delete data;
  if (name)
    delete	name;		// Delete our name string if it exists
  if (prev == 0)
    {
      if (parent != 0)
	parent->vals	= next;	// Unlink from parent if we are first in chain
    }
  else
    prev->next	= next;	// Unlink from prev if not first
  if (next != 0)
    next->prev	= prev;		// Unlink from next if not last
}

pstreamable *	RegVal::build()
{
  return new RegVal(pstreamableinit); // Create a new clean RegVal
}

char *	RegVal::getfullname()
{
  char *	p;
  if (parent)
    p	= parent->getfullname();
  else
    {
      p		= new char[1];
      p[0]	= 0;
    }
  if (name == 0)
    return p;
  char *	q	= new char[strlen(p) + strlen(name) + 2];
  strcpy(q, p);
// strcat(q, "|");      The name includes the prefix '|'.
  strcat(q, name);
  delete	p;
  return q;
}

void	RegVal::init()
{
  name		= 0;
  data		= 0;
  parent	= 0;
  next		= 0;
  prev		= 0;
}

pvoid	RegVal::read(ipstream &is) // Read ourselves from a stream
{
  is >> name >> data >> parent >> next >> prev;
  return this;
}

void	RegVal::write(opstream &os) // Write ourselves to a stream
{
  os << name << data << parent << next << prev;
}

pstreamreg	RegRegVal("RegVal", RegVal::build, __PSTREAM_DELTA(RegVal));


